<?php
  $file = "event.xml";
  $indent = 0;

  echo "<h1>Parsing XML with XML Parser functions</h1>";
  echo "Here is the parsed file: <br><br>";

  echo "&lt;?xml version='1.0'?&gt; <br>";

  $xml_parser_object = xml_parser_create();

  xml_set_element_handler($xml_parser_object, "startElement", "endElement");

  xml_set_character_data_handler($xml_parser_object, "text");

  xml_set_default_handler($xml_parser_object, "defaultHandler");

  if (!($handle = fopen($file, "r"))) {
    die("Error.");
  }

  while ($xml_data = fread($handle, 1024)) {
    if (!xml_parse($xml_parser_object, $xml_data, feof($handle))) {
      die(sprintf("Error %s on line %d",
        xml_error_string(xml_get_error_code($xml_parser_object)),
        xml_get_current_line_number($xml_parser_object)));
    }
  }

  xml_parser_free($xml_parser_object);

  fclose($handle);

  function defaultHandler($parser, $text) 
  {
    echo $text, "<br>";
  }

  function startElement($parser, $name, $attrs) 
  {
    global $indent;
    for ($i = 0; $i < $indent; $i++) {
        echo "&nbsp; &nbsp; ";
    }
    $lower = strtolower($name);
    $att_string = "";
    foreach ($attrs as $key => $value) {
      $att_string .= strtolower($key) . " = \"" . $value . "\"";
    }
    echo "&lt;${lower} ${att_string}&gt; <br>";
    $indent++;
  }

  function endElement($parser, $name) 
  {
    global $indent;
    $indent--;
    for ($i = 0; $i < $indent; $i++) {
        echo "&nbsp; &nbsp; ";
    }
    $lower = strtolower($name);
    echo "&lt;/${lower}&gt; <br>";
  }

  function text($parser, $text) 
  {
    global $indent;
    if(preg_match("/\S/", $text)){
    for ($i = 0; $i < $indent; $i++) {
        echo "&nbsp; &nbsp; ";
    }
      echo "$text <br>";
    }
  }
?> 